Loading...
Searching...
No Matches
Global Locking Routines
Apache Portability Runtime library
Collaboration diagram for Global Locking Routines:

## Typedefs

typedef struct apr_global_mutex_t | apr_global_mutex_t

## Functions

apr_status_t | apr_global_mutex_create (apr_global_mutex_t **mutex, const char *fname, apr_lockmech_e mech, apr_pool_t *pool)
apr_status_t | apr_global_mutex_child_init (apr_global_mutex_t **mutex, const char *fname, apr_pool_t *pool)
apr_status_t | apr_global_mutex_lock (apr_global_mutex_t *mutex)
apr_status_t | apr_global_mutex_trylock (apr_global_mutex_t *mutex)
apr_status_t | apr_global_mutex_timedlock (apr_global_mutex_t *mutex, apr_interval_time_t timeout)
apr_status_t | apr_global_mutex_unlock (apr_global_mutex_t *mutex)
apr_status_t | apr_global_mutex_destroy (apr_global_mutex_t *mutex)
const char * | apr_global_mutex_lockfile (apr_global_mutex_t *mutex)
apr_lockmech_e | apr_global_mutex_mech (apr_global_mutex_t *mutex)
const char * | apr_global_mutex_name (apr_global_mutex_t *mutex)
| APR_PERMS_SET_IMPLEMENT (global_mutex)
apr_pool_t * | apr_global_mutex_pool_get (const apr_global_mutex_t *theglobal_mutex)

## Detailed Description

## Typedef Documentation

## apr_global_mutex_t

typedef struct apr_global_mutex_t apr_global_mutex_t

Opaque global mutex structure.

## Function Documentation

## apr_global_mutex_child_init()

apr_status_t apr_global_mutex_child_init | ( | apr_global_mutex_t ** | mutex,
|  | const char * | fname,
|  | apr_pool_t * | pool
| ) |  |

Re-open a mutex in a child process.

Parameters

  mutex | The newly re-opened mutex structure.
  fname | A file name to use if the mutex mechanism requires one. This argument should always be provided. The mutex code itself will determine if it should be used. This filename should be the same one that was passed to apr_global_mutex_create().
  pool | The pool to operate on.

Remarks
  This function must be called to maintain portability, even if the underlying lock mechanism does not require it.

## apr_global_mutex_create()

apr_status_t apr_global_mutex_create | ( | apr_global_mutex_t ** | mutex,
|  | const char * | fname,
|  | apr_lockmech_e | mech,
|  | apr_pool_t * | pool
| ) |  |

Create and initialize a mutex that can be used to synchronize both processes and threads. Note: There is considerable overhead in using this API if only cross-process or cross-thread mutual exclusion is required. See apr_proc_mutex.h and apr_thread_mutex.h for more specialized lock routines.

Parameters

  mutex | the memory address where the newly created mutex will be stored.
  fname | A file name to use if the lock mechanism requires one. This argument should always be provided. The lock code itself will determine if it should be used.

  mech

  The mechanism to use for the interprocess lock, if any; one of

                 APR_LOCK_FCNTL
                 APR_LOCK_FLOCK
                 APR_LOCK_SYSVSEM
                 APR_LOCK_POSIXSEM
                 APR_LOCK_PROC_PTHREAD
                 APR_LOCK_DEFAULT     pick the default mechanism for the platform
                 APR_LOCK_DEFAULT_TIMED pick the default timed mechanism

  pool | the pool from which to allocate the mutex.

Warning
  Check APR_HAS_foo_SERIALIZE defines to see if the platform supports APR_LOCK_foo. Only APR_LOCK_DEFAULT is portable.

## apr_global_mutex_destroy()

apr_status_t apr_global_mutex_destroy | ( | apr_global_mutex_t * | mutex | ) |

Destroy the mutex and free the memory associated with the lock.

Parameters

  mutex | the mutex to destroy.

## apr_global_mutex_lock()

apr_status_t apr_global_mutex_lock | ( | apr_global_mutex_t * | mutex | ) |

Acquire the lock for the given mutex. If the mutex is already locked, the current thread will be put to sleep until the lock becomes available.

Parameters

  mutex | the mutex on which to acquire the lock.

## apr_global_mutex_lockfile()

const char * apr_global_mutex_lockfile | ( | apr_global_mutex_t * | mutex | ) |

Return the name of the lockfile for the mutex, or NULL if the mutex doesn't use a lock file

## apr_global_mutex_mech()

apr_lockmech_e apr_global_mutex_mech | ( | apr_global_mutex_t * | mutex | ) |

Get the mechanism of the mutex, as it relates to the actual method used for the underlying apr_proc_mutex_t.

Parameters

  mutex | the mutex to get the mechanism from.

## apr_global_mutex_name()

const char * apr_global_mutex_name | ( | apr_global_mutex_t * | mutex | ) |

Get the mechanism's name of the mutex, as it relates to the actual method used for the underlying apr_proc_mutex_t.

Parameters

  mutex | the mutex to get the mechanism's name from.

## apr_global_mutex_pool_get()

apr_pool_t * apr_global_mutex_pool_get | ( | const apr_global_mutex_t * | theglobal_mutex | ) |

Get the pool used by this global_mutex.

Returns
  apr_pool_t the pool

## apr_global_mutex_timedlock()

apr_status_t apr_global_mutex_timedlock | ( | apr_global_mutex_t * | mutex,
|  | apr_interval_time_t | timeout
| ) |  |

Attempt to acquire the lock for the given mutex until timeout expires. If the acquisition time outs, the call returns with APR_TIMEUP.

Parameters

  mutex | the mutex on which to attempt the lock acquiring.
  timeout | the relative timeout (microseconds).

Note
  A negative or nul timeout means immediate attempt, returning APR_TIMEUP without blocking if it the lock is already acquired.

## apr_global_mutex_trylock()

apr_status_t apr_global_mutex_trylock | ( | apr_global_mutex_t * | mutex | ) |

Attempt to acquire the lock for the given mutex. If the mutex has already been acquired, the call returns immediately with APR_EBUSY. Note: it is important that the APR_STATUS_IS_EBUSY(s) macro be used to determine if the return value was APR_EBUSY, for portability reasons.

Parameters

  mutex | the mutex on which to attempt the lock acquiring.

## apr_global_mutex_unlock()

apr_status_t apr_global_mutex_unlock | ( | apr_global_mutex_t * | mutex | ) |

Release the lock for the given mutex.

Parameters

  mutex | the mutex from which to release the lock.

## APR_PERMS_SET_IMPLEMENT()

APR_PERMS_SET_IMPLEMENT | ( | global_mutex |  | ) |

Set mutex permissions.